"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var primary_key_exports = {};
__export(primary_key_exports, {
  extractPrimaryKey: () => extractPrimaryKey,
  getFieldFromFieldMap: () => getFieldFromFieldMap
});
module.exports = __toCommonJS(primary_key_exports);
var import_assert = __toESM(require("assert"));
var import_helpers = require("../helpers");
function getFieldFromFieldMap(fieldMap, fieldName) {
  const field = fieldMap[fieldName];
  (0, import_assert.default)(field, `Expected field ${fieldName} to exist`);
  return field;
}
function extractPrimaryKey(type, fieldMap) {
  if ((0, import_helpers.hasDirective)("compositeKey", type)) {
    const directive = (0, import_helpers.getDirective)("compositeKey", type);
    const partitionKeyFields = (0, import_helpers.getArgStringArrayValue)(
      "pkFields",
      directive
    ).map((fieldName) => getFieldFromFieldMap(fieldMap, fieldName));
    const sortKeyFields = (0, import_helpers.getArgStringArrayValue)("skFields", directive).map(
      (fieldName) => getFieldFromFieldMap(fieldMap, fieldName)
    );
    return {
      isComposite: true,
      partitionKeyFields,
      partitionKeyIsSingleField: partitionKeyFields.length === 1,
      partitionKeyName: "pk",
      partitionKeyPrefix: (0, import_helpers.getOptionalArgStringValue)("pkPrefix", directive),
      sortKeyFields,
      sortKeyIsSingleField: sortKeyFields.length === 1,
      sortKeyName: "sk",
      sortKeyPrefix: (0, import_helpers.getOptionalArgStringValue)("skPrefix", directive),
      type: "primary"
    };
  }
  if ((0, import_helpers.hasDirective)("partitionKey", type)) {
    const directive = (0, import_helpers.getDirective)("partitionKey", type);
    const partitionKeyFields = (0, import_helpers.getArgStringArrayValue)(
      "pkFields",
      directive
    ).map((fieldName) => getFieldFromFieldMap(fieldMap, fieldName));
    return {
      isComposite: false,
      isSingleField: partitionKeyFields.length === 1,
      partitionKeyFields,
      partitionKeyName: "pk",
      partitionKeyPrefix: (0, import_helpers.getOptionalArgStringValue)("pkPrefix", directive),
      type: "primary"
    };
  }
  import_assert.default.fail(
    `Expected type ${type.name} to have a @partitionKey or @compositeKey directive`
  );
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  extractPrimaryKey,
  getFieldFromFieldMap
});
