"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var helpers_exports = {};
__export(helpers_exports, {
  filterNull: () => filterNull,
  getArg: () => getArg,
  getArgEnumValue: () => getArgEnumValue,
  getArgStringArrayValue: () => getArgStringArrayValue,
  getArgStringValue: () => getArgStringValue,
  getDirective: () => getDirective,
  getOptionalArg: () => getOptionalArg,
  getOptionalArgBooleanValue: () => getOptionalArgBooleanValue,
  getOptionalArgObjectValue: () => getOptionalArgObjectValue,
  getOptionalArgStringArrayValue: () => getOptionalArgStringArrayValue,
  getOptionalArgStringValue: () => getOptionalArgStringValue,
  getOptionalDirective: () => getOptionalDirective,
  hasDirective: () => hasDirective,
  hasInterface: () => hasInterface,
  isType: () => isType
});
module.exports = __toCommonJS(helpers_exports);
var import_assert = __toESM(require("assert"));
var import_graphql = require("graphql");
function getArg(name, directive) {
  (0, import_assert.default)(
    directive.arguments,
    `Expected @${directive} directive to have arguments`
  );
  const arg = directive.arguments?.find((a) => a.name.value === name);
  (0, import_assert.default)(arg, `${name} argument is required`);
  return arg;
}
function getOptionalArg(name, directive) {
  return directive.arguments?.find((arg) => arg.name.value === name);
}
function getArgStringValue(fieldName, directive) {
  const prefixArg = getArg(fieldName, directive);
  (0, import_assert.default)(
    prefixArg.value.kind === "StringValue",
    `Expected @${directive.name.value} directive argument "${fieldName}" to be a string, but got ${prefixArg.value.kind}`
  );
  return prefixArg.value.value;
}
function getArgEnumValue(fieldName, directive) {
  const prefixArg = getArg(fieldName, directive);
  (0, import_assert.default)(
    prefixArg.value.kind === "EnumValue",
    `Expected @${directive.name.value} directive argument "${fieldName}" to be an enum, but got ${prefixArg.value.kind}`
  );
  return prefixArg.value.value;
}
function getArgStringArrayValue(fieldName, directive) {
  const arg = getArg(fieldName, directive);
  (0, import_assert.default)(arg.value.kind === "ListValue", `Expected ${fieldName} to be a list`);
  return arg.value.values.map((v) => {
    (0, import_assert.default)(
      v.kind === "StringValue",
      `Expected @${directive.name.value} directive argument "${fieldName}" to be a list of strings`
    );
    return v.value;
  });
}
function getOptionalArgBooleanValue(fieldName, directive) {
  const prefixArg = getOptionalArg(fieldName, directive);
  if (!prefixArg) {
    return void 0;
  }
  (0, import_assert.default)(
    prefixArg.value.kind === "BooleanValue",
    `Expected @${directive.name.value} directive argument "${fieldName}" to be a boolean, but got ${prefixArg.value.kind}`
  );
  return Boolean(prefixArg.value.value);
}
function getOptionalArgStringArrayValue(fieldName, directive) {
  const arg = getOptionalArg(fieldName, directive);
  if (!arg) {
    return void 0;
  }
  (0, import_assert.default)(arg.value.kind === "ListValue", `Expected ${fieldName} to be a list`);
  return arg.value.values.map((v) => {
    (0, import_assert.default)(
      v.kind === "StringValue",
      `Expected @${directive.name.value} directive argument "${fieldName}" to be a list of strings`
    );
    return v.value;
  });
}
function getOptionalArgStringValue(fieldName, directive) {
  const prefixArg = getOptionalArg(fieldName, directive);
  if (!prefixArg) {
    return "";
  }
  (0, import_assert.default)(
    prefixArg.value.kind === "StringValue",
    `Expected @${directive.name.value} directive argument "${fieldName}" to be a string, but got ${prefixArg.value.kind}`
  );
  return prefixArg.value.value;
}
function getDirective(name, nodeOrType) {
  if ("getFields" in nodeOrType) {
    (0, import_assert.default)(nodeOrType.astNode, "Expected type to have an AST node");
    nodeOrType = nodeOrType.astNode;
  }
  const directive = nodeOrType.directives?.find((d) => d.name.value === name);
  (0, import_assert.default)(
    directive,
    `Expected field ${nodeOrType.name.value} to have an @${name} directive`
  );
  return directive;
}
function getOptionalDirective(name, nodeOrType) {
  if ("getFields" in nodeOrType) {
    (0, import_assert.default)(nodeOrType.astNode, "Expected type to have an AST node");
    nodeOrType = nodeOrType.astNode;
  }
  if ("astNode" in nodeOrType) {
    (0, import_assert.default)(nodeOrType.astNode);
    return nodeOrType.astNode.directives?.find((d) => d.name.value === name);
  }
  return nodeOrType.directives?.find((d) => d.name.value === name);
}
function hasDirective(directiveName, objType) {
  return !!objType.astNode?.directives?.map(({ name }) => name.value).includes(directiveName);
}
function hasInterface(interfaceName, objType) {
  return !!objType.astNode?.interfaces?.map(({ name }) => name.value).includes(interfaceName);
}
function isType(typeName, fieldType) {
  let { type } = fieldType;
  if ((0, import_graphql.isNonNullType)(type)) {
    type = type.ofType;
  }
  return (0, import_graphql.isScalarType)(type) && type.name === typeName;
}
function filterNull(x) {
  return Boolean(x);
}
function getOptionalArgObjectValue(fieldName, directive) {
  const arg = getOptionalArg(fieldName, directive);
  if (!arg) {
    return void 0;
  }
  (0, import_assert.default)(
    arg.value.kind === "ObjectValue",
    `Expected @${directive.name.value} directive argument "${fieldName}" to be an object, but got ${arg.value.kind}`
  );
  return coerceObject(arg.value);
}
function coerceObject(value) {
  (0, import_assert.default)(value.kind === "ObjectValue", "Expected an ObjectValue");
  return Object.fromEntries(
    value.fields.map(({ name: { value: name }, value: v }) => [
      name,
      coerceValue(v)
    ])
  );
}
function coerceValue(value) {
  switch (value.kind) {
    case "StringValue":
      return value.value;
    case "BooleanValue":
      return value.value;
    case "IntValue":
      return parseInt(value.value, 10);
    case "FloatValue":
      return parseFloat(value.value);
    case "EnumValue":
      return value.value;
    case "ListValue":
      return value.values.map(coerceValue);
    case "ObjectValue":
      break;
    case "NullValue":
      break;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  filterNull,
  getArg,
  getArgEnumValue,
  getArgStringArrayValue,
  getArgStringValue,
  getDirective,
  getOptionalArg,
  getOptionalArgBooleanValue,
  getOptionalArgObjectValue,
  getOptionalArgStringArrayValue,
  getOptionalArgStringValue,
  getOptionalDirective,
  hasDirective,
  hasInterface,
  isType
});
