"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var parser_exports = {};
__export(parser_exports, {
  parse: () => parse
});
module.exports = __toCommonJS(parser_exports);
var import_assert = __toESM(require("assert"));
var import_path = __toESM(require("path"));
var import_graphql = require("graphql");
var import_helpers = require("./helpers");
var import_models = require("./models");
var import_tables = require("./tables");
function parse(schema, documents, config, info) {
  const outputFile = info?.outputFile;
  (0, import_assert.default)(outputFile, "outputFile is required");
  const dependenciesModuleId = resolveDependenciesModuleId(config, {
    outputFile
  });
  const typesMap = schema.getTypeMap();
  const models = Array.from(
    new Set(
      Object.keys(typesMap).map((typeName) => schema.getTypeMap()[typeName]).filter((type) => (0, import_graphql.isObjectType)(type)).map((type) => (0, import_graphql.assertObjectType)(type)).filter((type) => (0, import_helpers.hasInterface)("Model", type)).map((type) => (0, import_models.extractModel)(config, schema, type, outputFile)).sort()
    )
  );
  const tables = Array.from(
    new Set(
      Object.keys(typesMap).map((typeName) => schema.getTypeMap()[typeName]).filter((type) => (0, import_graphql.isObjectType)(type)).map((type) => (0, import_graphql.assertObjectType)(type)).filter((type) => (0, import_helpers.hasInterface)("Model", type)).map((type) => (0, import_tables.extractTable)(config, schema, type, outputFile)).sort()
    )
  );
  return {
    additionalImports: models.flatMap((model) => model.fields.map((field) => field.computeFunction)).filter(import_helpers.filterNull),
    dependenciesModuleId,
    models,
    tables
  };
}
function resolveDependenciesModuleId(config, info) {
  (0, import_assert.default)(
    info?.outputFile,
    "You appear to be using this plugin in a context that does not require an output file. This is not supported."
  );
  const { dependenciesModuleId } = config;
  const { outputFile } = info;
  return dependenciesModuleId.startsWith(".") ? import_path.default.relative(
    import_path.default.resolve(process.cwd(), import_path.default.dirname(outputFile)),
    import_path.default.resolve(process.cwd(), dependenciesModuleId)
  ) : dependenciesModuleId;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  parse
});
