import { z } from "zod";
const LambdaConfigSchema = z.object({
  memorySize: z.number().default(256),
  timeout: z.number().default(30)
});
const DispatcherConfigSchema = LambdaConfigSchema.extend({
  batchSize: z.number().default(10),
  maximumRetryAttempts: z.number().default(3)
});
const HandlerConfigSchema = LambdaConfigSchema.extend({});
const ParserConfigSchema = z.object({
  actionsModuleId: z.string(),
  dependenciesModuleId: z.string(),
  dispatcherDefaults: DispatcherConfigSchema.default({}),
  handlerDefaults: HandlerConfigSchema.default({}),
  lambdaDefaults: LambdaConfigSchema.default({}),
  tableDefaults: z.object({ enablePointInTimeRecovery: z.boolean().default(true) }).default({}),
  useEfficientIndexes: z.boolean().default(true)
});
export {
  DispatcherConfigSchema,
  HandlerConfigSchema,
  LambdaConfigSchema,
  ParserConfigSchema
};
